{$R+}
Program h;
{vvod. *.ZMT s dlinami sv`azej i uglami (r/alfa/hi), 
  a vyv. - v dekart. koord. (xyz);
  pri etom perekh. k os`am ellipsoida inertsii, a dl`a simm. volchkov odin iz
  at.  perevodim v pl-st` x0z; net spets. obrab. sfer. volchkov}

 {$i subrgeom.pas}
 {$i diago.pas}

 const nAtMax=400;
 type s5=string[2];
 type atom=record obozn:s5; r:vect3; sv:array[1..6] of integer; end;
 var atomy:array[1..nAtMax] of atom; nAtom:integer;

 type s80=string[80];
 var s1,s2,s3,s:s80; b,bb:text;

 var i,j,k,op_r,op_fi,op_hi,sv_r,sv_fi,sv_hi:integer;
 var rr,fi,hi,r1,r2,r3,c,ss,x,y,pp:real;
 var ende:boolean;
 var a1,a2,a3,xx,yy,zz,hh,x23,centr:vect3;
 var grad:real;
 var inerts,t:matr; d:vect;

 function vylez(i,i0,i1:integer):boolean; begin vylez:=(i<i0) or (i>i1); end;

 procedure vyv(imya:string; s1,s2,s3:s80);
  var bb:text; i,j,k:integer; s,ss:string[12];
  const aa=1.0; b=1.0; c=1.0; alpha=90.0; beta=90.0; gamma=90.0;
 begin
  assign(bb,imya); rewrite(bb);
  if s1<>'' then writeln(bb,s1) else writeln(bb);
  if s2<>'' then writeln(bb,s2) else writeln(bb,'  Name: D:\GALINA\H2O2_.ZMT');
  if s3<>'' then writeln(bb,s3) else
    writeln(bb,'  MOPAC file created on 19/3 11:31:58 1998 by HYPERCHEM');
  for i:=1 to nAtom do with atomy[i] do begin
   write(bb,copy(obozn,1,2),'   ');
   for j:=1 to 3 do begin
    str(abs(r[j]):10:4,ss);
    s:='';
    for k:=1 to length(ss) do if ss[k]=' ' then s:=s+'0' else s:=s+ss[k];
    if r[j]>=0 then s:=' '+s else s:='-'+s;
    write(bb,s,' 1 ');
   end;
   writeln(bb);
  end;
  writeln(bb,'0');
  writeln(bb);
  close(bb);
 end;
(*
 function tipy(i,j:integer; a1,a2:s5):boolean; var s1,s2:s5;
 begin
  if (length(a1)<>2) or (length(a2)<>2) then begin
   writeln('tipy - l<>2.'); halt;
  end;
  s1:=copy(atomy[i].obozn,1,2); s2:=copy(atomy[j].obozn,1,2);
  tipy:=((s1=a1) and (s2=a2)) or ((s1=a2) and (s2=a1));
 end;
*)
Begin writeln; grad:=pi/180;
 if paramcount<>2 then begin
  writeln('Obr: prog infile outfile .'); 
  writeln('Vkhodn. fajl - *.ZMT tipa r/alfa/hi;');
  writeln('  vykh. fajl - *.ZMT tipa xyz;');
  writeln('  zaodno perekh. k centru mass i os`am ellipsoida inerts.');
  halt;
 end;
 {-----------------------------}
 {vvod dannykh s odnovr. postr. dekart. koord. vsekh at.}
 assign(b,paramstr(1)); reset(b);
 assign(bb,'tempor.txt');
 readln(b,s1); readln(b,s2); readln(b,s3);
 i:=0; repeat
  readln(b,s);
  if copy(s,1,1)<>'0' then begin
   i:=i+1; atomy[i].obozn:=copy(s,1,2); s:=copy(s,3,80);
   rewrite(bb); writeln(bb,s); close(bb);
   reset(bb); readln(bb,rr,op_r,fi,op_fi,hi,op_hi,sv_r,sv_fi,sv_hi); close(bb);
   fi:=fi*grad; hi:=hi*grad;
   if i=1 then initvect(atomy[1].r,0,0,0);
   if i=2 then initvect(atomy[2].r,rr,0,0);
   if i=3 then begin
    if sv_r=1 then
      initvect(atomy[3].r,atomy[1].r[1]+rr*cos(fi),atomy[1].r[2]+rr*sin(fi),0)
    else if sv_r=2 then
      initvect(atomy[3].r,atomy[2].r[1]-rr*cos(fi),atomy[2].r[2]+rr*sin(fi),0)
    else begin writeln('!!!'); halt; end;
   end;
   if i>3 then begin
    if vylez(sv_r,1,i-1) or vylez(sv_fi,1,i-1) or vylez(sv_hi,1,i-1) then begin
     writeln('Vylez. nomer oporn. atoma; i=',i); halt;
    end;
    a1:=atomy[sv_r].r; a2:=atomy[sv_fi].r; a3:=atomy[sv_hi].r;
    for j:=1 to 3 do begin zz[j]:=a1[j]-a2[j]; x23[j]:=a3[j]-a2[j]; end;
    norm(zz); para_perp(zz,x23,hh,xx); norm(xx); vecpro(zz,xx,yy);
    {vozm., dl`a L/D-asimm. nado yy brat` s obr. znakom}
    r1:=rr*sin(fi)*cos(hi); r2:=rr*sin(fi)*sin(hi); r3:=-rr*cos(fi);
    for j:=1 to 3 do atomy[i].r[j]:=a1[j]+r1*xx[j]+r2*yy[j]+r3*zz[j];
   end {if i>3};
   {with atomy[i] do writeln(i:5,' ',obozn:2,r[1]:10:4,r[2]:10:4,r[3]:10:4);}
  end {copy(s,1,1)<>'0'};
  ende:=eof(b) or (copy(s,1,1)='0');
 until ende;
 close(b);
 nAtom:=i;
 {-------------------------------}
 {perekh. k tsentru mass}
 initvect(centr,0,0,0);
 for i:=1 to nAtom do for j:=1 to 3 do centr[j]:=centr[j]+atomy[i].r[j];
 for j:=1 to 3 do centr[j]:=centr[j]/nAtom;
 for i:=1 to nAtom do for j:=1 to 3 do atomy[i].r[j]:=atomy[i].r[j]-centr[j];
 {------------------------------}
 {ishchem momenty inertsii}
 {Izz = ne z^2, a r^2-z^2 = x^2+y^2; eto obesp. posle sortir. SZ po vozrast.
    dl`a plosk. molek. imenno z=0}
 pp:=0; for k:=1 to nAtom do pp:=pp+norma2(atomy[k].r);
 for i:=1 to 3 do for j:=1 to 3 do begin
  if i=j then ss:=pp else ss:=0;
  for k:=1 to nAtom do ss:=ss-atomy[k].r[i]*atomy[k].r[j]; inerts[i,j]:=ss;
 end;
 {------------------------------}
 {perekh. k os`am inertsii}
 diag(inerts,t,d,3,1.0e-5);
 initvect(xx,t[1,1],t[2,1],t[3,1]);
 initvect(yy,t[1,2],t[2,2],t[3,2]);
 initvect(zz,t[1,3],t[2,3],t[3,3]);
 for i:=1 to nAtom do begin
  r1:=scapro(atomy[i].r,xx);
  r2:=scapro(atomy[i].r,yy);
  r3:=scapro(atomy[i].r,zz);
  initvect(atomy[i].r,r1,r2,r3);
 end;
 {------------------}
 {esli simm. volchok - izbrann. atom perevodim v pl-st` x0z}
 writeln('Momenty inerts.:',d[1]:10:4,d[2]:10:4,d[3]:10:4);
 if (d[3]-d[2])/d[2]<0.0005 then begin
 {vyt`anut. volchok; nado vnachale perestav. x s z}
  for i:=1 to nAtom do with atomy[i] do begin
   r1:=r[1]; r[1]:=r[3]; r[3]:=r1;
  end;
  r1:=d[1]; d[1]:=d[3]; d[3]:=r1;
 end;
 if (d[2]-d[1])/d[2]<0.0005 then begin
 {simm. volchok: nado povern. v xy}
  i:=0; repeat i:=i+1 until sqrt(sqr(atomy[i].r[1])+sqr(atomy[i].r[2]))>0.01;
  initvect(zz,0,0,1); para_perp(zz,atomy[i].r,hh,xx); initvect(hh,1,0,0);
  fi:=ugol2(hh,xx);
  c:=cos(fi); ss:=sin(fi);
  {ugol ne opr. napr. povorota - nado ispyt. oba}
  if abs(-ss*atomy[i].r[1]+c*atomy[i].r[2])<0.001 then
  else if abs(ss*atomy[i].r[1]+c*atomy[i].r[2])<0.001 then ss:=-ss
  else begin writeln('Osh. v prog. povorota!!!'); halt; end;
  for i:=1 to nAtom do with atomy[i] do begin
   x:=r[1]; y:=r[2]; r[1]:=c*x+ss*y; r[2]:=-ss*x+c*y;
  end;
 end;
 {------------------}
 vyv(paramstr(2),s1,s2,s3);
 {------------------}
End.
