{$R+}
Program h; uses dos;
{chitaet *.MOL (v t.ch. kosougol`n.), vyvodit *.X_r (obozn.+xyz)}

 {$i vspo_dos.pas} {erase_if_exist - udal. tempor.txt v kontse}
 {$i subrgeom.pas}
 {$i constant.pas}

 const n_zapis_max=1000;
 type s2=string[2];
 type zapis=record r:vect3; sv:array[1..6] of integer; obozn:s2; end;
 var atomy:array[1..n_zapis_max] of zapis;
 var i,nAtom:integer;
 var b,bb:text; s:string[80];
(*
 procedure show_geom(i,j,k,l:integer);
 begin
  write(i:2,'-',j:2,'-',k:2,'-',l:2,' = ',atomy[i].obozn,'-',atomy[j].obozn,'-',
    atomy[k].obozn,'-',atomy[l].obozn);
  write(': r=',rasst(atomy[k].r,atomy[l].r):6:4);
  write('; al=',ugol(atomy[j].r,atomy[k].r,atomy[l].r)/grad:6:2);
  writeln('; hi=',dvugr(atomy[i].r,atomy[j].r,atomy[k].r,atomy[l].r)/grad:6:2);
 end;
*)
 procedure vyv_obo_xyz(imya:string); var bb:text; i:integer;
 begin
  assign(bb,imya); rewrite(bb);
  for i:=1 to nAtom do begin
   with atomy[i] do writeln(bb,obozn,'  ',r[1]:12:6,r[2]:12:6,r[3]:12:6);
  end;
  close(bb);
 end;
(*
 procedure vyv_mol(imya:string);
  var bb:text; i,j:integer;
  const aa=1.0; b=1.0; c=1.0; alpha=90.0; beta=90.0; gamma=90.0;
 begin
  assign(bb,imya); rewrite(bb);
  for i:=1 to 39 do write(bb,' ');
  writeln(bb,aa:8:4,b:8:4,c:8:4);
  for i:=1 to 22 do write(bb,' ');
  writeln(bb,alpha:8:3,' ',beta:8:3,' ',gamma:8:3);
  writeln(bb,nAtom:4); writeln(bb);
  for i:=1 to nAtom do with atomy[i] do begin
   write(bb,i:4,' ',copy(obozn,1,2),' ');
   for j:=1 to 3 do write(bb,r[j]:10:5);
   for j:=1 to 6 do write(bb,sv[j]:4);
   writeln(bb);
  end;
  close(bb);
 end;

 procedure vyv_zmt(imya:string);
  var bb:text; i,j,k:integer; s,ss:string[12];
 begin
  assign(bb,imya); rewrite(bb);
  writeln(bb);
  writeln(bb,'  Name: D:\GALINA\H2O2_.ZMT');
  writeln(bb,'  MOPAC file created on 19/3 11:31:58 1998 by HYPERCHEM');
  for i:=1 to nAtom do with atomy[i] do begin
   write(bb,copy(obozn,1,2),'   ');
   for j:=1 to 3 do begin
    str(abs(r[j]):10:4,ss);
    s:='';
    for k:=1 to length(ss) do if ss[k]=' ' then s:=s+'0' else s:=s+ss[k];
    if r[j]>=0 then s:=' '+s else s:='-'+s;
    write(bb,s,' 1 ');
   end;
   writeln(bb);
  end;
  writeln(bb,'0');
  writeln(bb);
  close(bb);
 end;
*)
 var baz:bazis; q:vect3; aa,bb_,cc,alfa,beta,gamma:real;

Begin
 if paramcount<>2 then begin
  writeln('Obr.: prog infile.mol outfile.X_r .'); halt;
 end;
 initmnozh;
 {----------------}
 assign(b,paramstr(1)); reset(b);
 assign(bb,'tempor.txt');
 readln(b,aa,bb_,cc);
 readln(b,alfa,beta,gamma);
 alfa:=alfa*grad; beta:=beta*grad; gamma:=gamma*grad;
 postr_bazis(aa,bb_,cc,alfa,beta,gamma,baz);
 readln(b); readln(b);
 i:=0; while not eof(b) do begin
  i:=i+1; with atomy[i] do begin
   readln(b,s); if length(s)<62 then writeln('Podozrit. atom: /',s,'/');
   obozn:=copy(s,6,2); if obozn='  ' then obozn:='XX';
   rewrite(bb); writeln(bb,copy(s,8,80));
   reset(bb); readln(bb,q[1],q[2],q[3],sv[1],sv[2],sv[3],sv[4],sv[5],sv[6]);
   u_Av(r,baz,q);
  end {with};
 end; nAtom:=i;
 close(b); close(bb);
 {----------------}
 erase_if_exists('tempor.txt');
 vyv_obo_xyz(paramstr(2));
 {vyv_mol('ultra_.mol');}
 {vyv_zmt('ultra_.zmt');}
End.
