{$R+}
Program h;
{Chitaetsa *.X_r (obozn+xyz), vyvoditsa *.MOL dl`a vv. v prog. ATOM}
 {$i subrgeom.pas}
 type s5=string[2];
 type atom=record obozn:s5; r:vect3; sv:array[1..6] of integer; end;
 var atomy:array[1..1600] of atom; nAtom:integer;
 var b:text; i:integer;

 procedure vyv(imya:string);
  var bb:text; i,j:integer;
  const aa=1.0; b=1.0; c=1.0; alpha=90.0; beta=90.0; gamma=90.0;
 begin
  assign(bb,imya); rewrite(bb);
  for i:=1 to 39 do write(bb,' ');
  writeln(bb,aa:8:4,b:8:4,c:8:4);
  for i:=1 to 22 do write(bb,' ');
  writeln(bb,alpha:8:3,' ',beta:8:3,' ',gamma:8:3);
  writeln(bb,nAtom:4); writeln(bb);
  for i:=1 to nAtom do with atomy[i] do begin
   write(bb,i:4,' ',copy(obozn,1,2),' ','  ');
   for j:=1 to 3 do write(bb,' ',r[j]:9:5);
   for j:=1 to 6 do write(bb,' ',sv[j]:3);
   writeln(bb);
  end;
  close(bb);
 end;
(*
 function tipy(i,j:integer; a1,a2:s5):boolean; var s1,s2:s5;
 begin
  if (length(a1)<>2) or (length(a2)<>2) then begin
   writeln('tipy - l<>2.'); halt;
  end;
  s1:=copy(atomy[i].obozn,1,2); s2:=copy(atomy[j].obozn,1,2);
  tipy:=((s1=a1) and (s2=a2)) or ((s1=a2) and (s2=a1));
 end;
*)

 function gut(i,j:integer; s1,s2:s5; rmin,rmax:real):boolean;
  var g1,g2:boolean; r:real;
 begin
  g1:=
    ((atomy[i].obozn=s1) and (atomy[j].obozn=s2))
     or
    ((atomy[i].obozn=s2) and (atomy[j].obozn=s1));
  if not g1 then begin gut:=false; exit; end;
  r:=rasst(atomy[i].r,atomy[j].r);
  g2:=(r>=rmin) and (r<=rmax);
  gut:=g1 and g2;
 end;

 function nado_sv(i,j:integer):boolean;
  var g1,g2,g3,g4,g:boolean; r:real;
 begin
  r:=rasst(atomy[i].r,atomy[j].r);

  g1:=((r>0.9) and (r<1.15))
        or
      (
       ((copy(atomy[i].obozn,1,2)<>'H ') and (copy(atomy[j].obozn,1,2)<>'H '))
         and
       (r<2.0)
      );

  g2:=
       gut(i,j,'C ','H ',0.8,1.35)
    or gut(i,j,'C ','C ',1.2,1.9)
    or gut(i,j,'Si','H ',1.2,1.6)
    or gut(i,j,'Si','C ',1.5,2.3)
    or gut(i,j,'Si','Si',2.0,2.8)
    ;
  g:=g2 or g1;
  if g then writeln(i:5,j:5,r:10:4,' ',atomy[i].obozn, ' ',atomy[j].obozn);
  nado_sv:=g;
 end;

 procedure prost_sv;
  var i,j,k:integer; x,y,z,x_,y_,z_,r:real;
 begin
  for i:=1 to nAtom do begin
  for j:=i+1 to nAtom do begin
   {write(i:5,j:5,'   ',chr($0D));}
   if nado_sv(i,j) then begin
    k:=0; repeat k:=k+1 until (k=9) or (atomy[i].sv[k]=0);
    if k<7 then atomy[i].sv[k]:=j else writeln(i:5,j:5,r:10:4,' >6 sv`azej.');
    k:=0; repeat k:=k+1 until (k=9) or (atomy[j].sv[k]=0);
    if k<7 then atomy[j].sv[k]:=i else writeln(j:5,i:5,r:10:4,' >6 sv`azej.');
   end;
  end end;
 end;

Begin writeln;
 if paramcount<>2 then begin
  writeln('Obr.: progr infile.X_r outfile.mol .'); halt;
 end;
 nAtom:=0;
 assign(b,paramstr(1)); reset(b);
 while not eof(b) do begin nAtom:=nAtom+1;
  with atomy[nAtom] do begin
   readln(b,obozn,r[1],r[2],r[3]); for i:=1 to 6 do sv[i]:=0;
   writeln('/',obozn,'/');
  end;
 end;
 close(b);
 prost_sv;
 vyv(paramstr(2));
End.
