{$R+}
Program h; uses dos;
{predvar. prosm. fajlov *.ZMT}
 {$i vspo_dos.pas}
 {$i subrgeom.pas}

 const nAtMax=400;
 type s5=string[2];
 type atom=record obozn:s5; r:vect3; sv:array[1..6] of integer; end;
 var atomy:array[1..nAtMax] of atom; nAtom:integer; {n_zapis:integer;}

 type s80=string[80];
 var s1,s2,s3,s:s80; b,bb:text;

 var i,j,op_r,op_fi,op_hi,sv_r,sv_fi,sv_hi,n:integer;
 var rr,fi,hi,r1,r2,r3:real;
 var ende:boolean;
 var a1,a2,a3,xx,yy,zz,hh,x23:vect3;
 var grad:real;
 var r_fi_hi:boolean; 

 function vylez(i,i0,i1:integer):boolean; begin vylez:=(i<i0) or (i>i1); end;
(*
 function tipy(i,j:integer; a1,a2:s5):boolean; var s1,s2:s5;
 begin
  if (length(a1)<>2) or (length(a2)<>2) then begin
   writeln('tipy - l<>2.'); halt;
  end;
  s1:=copy(atomy[i].obozn,1,2); s2:=copy(atomy[j].obozn,1,2);
  tipy:=((s1=a1) and (s2=a2)) or ((s1=a2) and (s2=a1));
 end;
*)
 procedure vvod_r_fi_hi;
 begin
  {vvod dannykh s odnovr. postr. dekart. koord. vsekh at.}
  assign(b,paramstr(1)); reset(b);
  assign(bb,'tempor.txt');
  readln(b,s1); readln(b,s2); readln(b,s3);
  i:=0; repeat
   readln(b,s);
   if {copy(s,1,1)<>'0'}length(s)>2 then begin
    i:=i+1; atomy[i].obozn:=copy(s,1,2); s:=copy(s,3,80);
    rewrite(bb); writeln(bb,s); close(bb);
    reset(bb); readln(bb,rr,op_r,fi,op_fi,hi,op_hi,sv_r,sv_fi,sv_hi); close(bb);
    fi:=fi*grad; hi:=hi*grad;
    if i=1 then initvect(atomy[1].r,0,0,0);
    if i=2 then initvect(atomy[2].r,rr,0,0);
    if i=3 then begin
     if sv_r=1 then
       initvect(atomy[3].r,atomy[1].r[1]+rr*cos(fi),atomy[1].r[2]+rr*sin(fi),0)
     else if sv_r=2 then
       initvect(atomy[3].r,atomy[2].r[1]-rr*cos(fi),atomy[2].r[2]+rr*sin(fi),0)
     else begin writeln('!!!'); halt; end;
    end;
    if i>3 then begin
     if vylez(sv_r,1,i-1) or vylez(sv_fi,1,i-1) or vylez(sv_hi,1,i-1) then begin
      writeln('Vylez. nomer oporn. atoma; i=',i); halt;
     end;
     a1:=atomy[sv_r].r; a2:=atomy[sv_fi].r; a3:=atomy[sv_hi].r;
     for j:=1 to 3 do begin zz[j]:=a1[j]-a2[j]; x23[j]:=a3[j]-a2[j]; end;
     norm(zz); para_perp(zz,x23,hh,xx); norm(xx); vecpro(zz,xx,yy);
     {vozm., dl`a L/D-asimm. nado yy brat` s obr. znakom}
     r1:=rr*sin(fi)*cos(hi); r2:=rr*sin(fi)*sin(hi); r3:=-rr*cos(fi);
     for j:=1 to 3 do atomy[i].r[j]:=a1[j]+r1*xx[j]+r2*yy[j]+r3*zz[j];
    end {if i>3};
    {with atomy[i] do writeln(i:5,' ',obozn:2,r[1]:10:4,r[2]:10:4,r[3]:10:4);}
   end {copy(s,1,1)<>'0'};
   ende:=eof(b) or (copy(s,1,1)='0');
  until ende;
  close(b);
  nAtom:=i;
 end;
 procedure vvod_dekart; var op1,op2,op3:integer;
 begin
  {vvod dannykh, uzhe predst. kak dekart. koord. vsekh at.}
  assign(b,paramstr(1)); reset(b);
  assign(bb,'tempor.txt');
  readln(b,s1); readln(b,s2); readln(b,s3);
  i:=0; repeat
   readln(b,s);
   if copy(s,1,1)<>'0' then begin
    i:=i+1; atomy[i].obozn:=copy(s,1,2); s:=copy(s,3,80);
    rewrite(bb); writeln(bb,s); close(bb);
    reset(bb); with atomy[i] do readln(bb,r[1],op1,r[2],op2,r[3],op3); close(bb);
    {with atomy[i] do writeln(i:5,' ',obozn:2,r[1]:10:4,r[2]:10:4,r[3]:10:4);}
   end {copy(s,1,1)<>'0'};
   ende:=eof(b) or (copy(s,1,1)='0');
  until ende;
  close(b);
  nAtom:=i;
 end;

 procedure vyv_obo_xyz(imya:string); var bb:text; i:integer;
 begin
  assign(bb,imya); rewrite(bb);
  for i:=1 to nAtom do begin
   with atomy[i] do writeln(bb,obozn,'  ',r[1]:12:6,r[2]:12:6,r[3]:12:6);
  end;
  close(bb);
 end;

Begin
 if (paramcount<>2) then begin
  writeln('Obr: prog infile.zmt outfile.X_r .');
  writeln('Raspoznajot *.ZMT tipov r/alfa/hi i xyz .');
  halt;
 end;
 grad:=pi/180;
 {-----------------------------}
 assign(b,paramstr(1)); reset(b);
 for i:=1 to 3 do begin readln(b,s); {writeln(copy(s,1,78));} end;
 repeat s1:=s; readln(b,s); until eof(b) or (length(s)<=1); s:=s1;
 {poluch. posledn. stroku s opis. atoma}
 close(b);
 n:=0; for i:=1 to length(s) do
   if ((i=1) or (s[i-1]=' ')) and (s[i]<>' ') then n:=n+1; {chislo itemov}
 if n=7 then begin r_fi_hi:=false; {writeln('Dekartov.');} end
 else if n=10 then begin r_fi_hi:=true; {writeln('Cherez r/fi/hi.');} end
 else begin writeln('n=',n,' - ne MOPAC',chr($27),'ovsk. fajl.'); halt; end;
 {-----------------------------}
 if r_fi_hi then vvod_r_fi_hi else vvod_dekart;
 {-----------------------------}
(*
 writeln(s1); writeln(s2); writeln(s3);
 if r_fi_hi then writeln('Tip r/fi/hi.') else writeln('Dekartov.');
*)
 erase_if_exists('tempor.txt');
 vyv_obo_xyz(paramstr(2));
End.
